;Allgemeiner Krimskrams
Global gfx_w=800
Global gfx_h=600
Graphics gfx_w,gfx_h,0,2
Global apptit$="Logikgatter-Simu 0.6"
AppTitle apptit$
SeedRnd MilliSecs()

Local timer=CreateTimer(30)

;Input-Vars
Global ctrl_mhit,ctrl_mhit2,ctrl_mx,ctrl_my
Global escape,del

;Tile-Map-Vars
Global tile_w=60
Global tile_h=60
Global map_w=(gfx_w-40)/tile_w-3
Global map_h=gfx_h/tile_h-1
Dim map.part(map_w,map_h)
Dim state(map_w,map_h)
Dim visited(map_w,map_h)

;"State-Machine"
Const MODE_MENU=0
Const MODE_EDITOR=1
Const MODE_SIMU=2
Const MODE_LOAD=3
Const MODE_SAVE=4
Global gamemode=MODE_MENU

;Zum Script einlesen
Dim script_para(0)
Global script_para_count

;Editor-Vars
Global editor_selected.part
Global savename$

;Die verfgbaren Bausteine
Type part
	Field operation
	Field img
	Field script$
	Field directions
End Type

;einige Konstenten zur besseren bersicht
Const OP_NONE=0
Const OP_AND=1
Const OP_OR=2
Const OP_NOT=3
Const OP_XOR=4

;Const DIR_NONE=0
Const DIR_RIGHT=1
Const DIR_LEFT=2
Const DIR_UP=3
Const DIR_DOWN=4

Dim OP_NAMES$(4)
OP_NAMES(OP_NONE)="Einfacher Leiter"
OP_NAMES(OP_AND)="And / Konjunktion"
OP_NAMES(OP_OR)="Or / Disjunktion"
OP_NAMES(OP_NOT)="Not / Negation"
OP_NAMES(OP_XOR)="Xor / Exklusiv Oder"

;Alle laden
Global firstpart.part=AddPart(OP_NONE,"none_hor.txt")
AddPart(OP_NONE,"none_ver.txt")
AddPart(OP_NONE,"none_lo.txt")
AddPart(OP_NONE,"none_lu.txt")
AddPart(OP_NONE,"none_ro.txt")
AddPart(OP_NONE,"none_ru.txt")

AddPart(OP_NONE,"none_lou.txt")
;AddPart(OP_NONE,"none_rou.txt")
;AddPart(OP_NONE,"none_olr.txt")
;AddPart(OP_NONE,"none_ulr.txt")
AddPart(OP_NONE,"none_crossover.txt")

AddPart(OP_AND,"and.txt")
AddPart(OP_OR,"or.txt")
AddPart(OP_NOT,"not.txt")
AddPart(OP_XOR,"xor.txt")

;Herumfliegende Buchstaben frs Men
Type menu_char
	Field char$
	Field x#,y#
	Field target_x,target_y
End Type
MenuSetup()

;Frs Speichern / lade
Type file
	Field name$
End Type

;DoubleBuffering
SetBuffer BackBuffer()

;Hauptschleife
Repeat
	GetInput()
	
	;Was machen wir grad?
	Select gamemode
		Case MODE_MENU
			DoMenu()
		Case MODE_EDITOR
			DoEditor()
		Case MODE_SIMU
			DoSimu()
			UpdateSimulation()
		Case MODE_LOAD
			DoMenuLoad()
		Case MODE_SAVE
			DoMenuSave()
	End Select
	
	Flip 0:Cls
	WaitTimer timer
Forever
End

;Maus-Input in Vars speichern
Function GetInput()
	ctrl_mx=MouseX()
	ctrl_my=MouseY()
	ctrl_mhit=MouseHit(1)
	ctrl_mhit2=MouseHit(2)
	escape=KeyHit(1)
	del=KeyHit(211)
End Function

;Herum fliegende Buchstaben vorbereiten (Buchstaben zufllig verteilen)
Function MenuSetup()
	Delete Each menu_char
	Local m.menu_char
	Local x=(gfx_w-(Len(apptit$)+1)*15)/2
	For i=1 To Len(apptit$)
		m=New menu_char
		m\char=Mid(apptit$,i,1)
		m\x=Rand(0,800)
		m\y=Rand(0,600)
		m\target_x=x+i*15
		m\target_y=50
	Next
End Function

;Das ganze Menu
Function DoMenu()
	Local m.menu_char
	
	;Herumfliegende Buchstaben malen
	For m=Each menu_char
		Text m\x,m\y,m\char$,1,1
		m\x#=m\x-(m\x-m\target_x)/10
		m\y#=m\y-(m\y-m\target_y)/10
	Next
	
	;Buttons
	If Button(300,250,"Start",200,50) Then
		Editor_SetupMap()
		editor_selected=First part
		gamemode=MODE_EDITOR
	EndIf
	If Button(300,350,"Ende",200,50) Or escape Then
		End
	EndIf
End Function

;Billigsdorfer-Button, einfach und zweckmig
Function Button(x,y,txt$,w=100,h=20)
	Rect x,y,w,h,0
	If ctrl_mx>x And ctrl_mx<x+w Then
		If ctrl_my>y And ctrl_my<y+h Then
			Rect x+1,y+1,w-2,h-2,0
			If ctrl_mhit Then
				Return True
			EndIf
		EndIf
	EndIf
	Text x+w/2,y+h/2,txt$,1,1
	Return False
End Function

;Einen Teil laden mit bestimmten Verhalten (op) und Aussehen (in script)
Function AddPart.part(op,script$)
	;Script ffnen
	Local reader=ReadFile("scripts\"+script$)
	If reader=0 Then
		RuntimeError "Kann 'scripts\"+script$+"' nicht finden"
	EndIf
	;Teil anlegen
	Local part.part=New part
	part\operation=op
	part\script$=script$
	part\img=CreateImage(tile_w,tile_h)
	SetBuffer ImageBuffer(part\img)
	
	Local txt$,space,keyword$,para$
	Local a,b,c,d,e
	
	;Zeichen-Anweisungen in Script zeilenweise verarbeiten
	While Not Eof(reader)
		;Zeile bissi "preparsen"
		txt$=ReadLine(reader)
		If Instr(txt$,";")>0 Then
			txt$=Left(txt$,Instr(txt$,";")-1)
		EndIf
		txt$=Trim(txt$)
		If txt$<>"" Then
			;In Befehl und Parameter zerlegen
			space=Instr(txt$," ")
			If space=0 Then
				RuntimeError "Leerzeichen erwartet in Zeile: "+Chr(10)+txt$
			EndIf
			keyword$=Lower(Left(txt$,space-1))
			para$=Mid(txt$,space+1)
			GetParameter(para$)
			
			;Je nach Befehl immer Anzahl der Parameter berprfen, diese ggf. umrechnen und was tun damit
			Select keyword$
				Case "line"
					If script_para_count<>4 Then
						RuntimeError "4 Parameter erwartet in Zeile: "+Chr(10)+txt$
					EndIf
					a=(script_para(0)/100.0)*tile_w
					b=(script_para(1)/100.0)*tile_h
					c=(script_para(2)/100.0)*tile_w
					d=(script_para(3)/100.0)*tile_h
					Line a,b,c,d
				Case "color"
					If script_para_count<>3 Then
						RuntimeError "3 Parameter erwartet in Zeile: "+Chr(10)+txt$
					EndIf
					a=script_para(0)
					b=script_para(1)
					c=script_para(2)
					Color a,b,c
				Case "rect"
					If script_para_count<>5 Then
						RuntimeError "5 Parameter erwartet in Zeile: "+Chr(10)+txt$
					EndIf
					a=(script_para(0)/100.0)*tile_w
					b=(script_para(1)/100.0)*tile_h
					c=(script_para(2)/100.0)*tile_w
					d=(script_para(3)/100.0)*tile_h
					e=script_para(4)
					Rect a,b,c,d,e
				Case "oval"
					If script_para_count<>5 Then
						RuntimeError "5 Parameter erwartet in Zeile: "+Chr(10)+txt$
					EndIf
					a=(script_para(0)/100.0)*tile_w
					b=(script_para(1)/100.0)*tile_h
					c=(script_para(2)/100.0)*tile_w
					d=(script_para(3)/100.0)*tile_h
					e=script_para(4)
					Oval a,b,c,d,e
				Case "text"
					If script_para_count<3 Then
						RuntimeError "Mind. 3 Parameter erwartet in Zeile: "+Chr(10)+txt$
					EndIf
					a=(script_para(0)/100.0)*tile_w
					b=(script_para(1)/100.0)*tile_h
					t$=""
					For i=2 To script_para_count-1
						t$=t$+Chr(script_para(i))
					Next
					Text a,b,t$,1,1
				Case "direction"
					If script_para_count<>4 Then
						RuntimeError "4 Parameter erwartet in Zeile: "+Chr(10)+txt$
					EndIf
					a=script_para(0) Shl DIR_RIGHT
					b=script_para(1) Shl DIR_LEFT
					c=script_para(2) Shl DIR_UP
					d=script_para(3) Shl DIR_DOWN
					part\directions=a+b+c+d
				Default
					RuntimeError "Unbekannter Befehl in Zeile: "+Chr(10)+txt$
			End Select
		EndIf
	Wend
	CloseFile reader
	Return part
End Function

;Hilfsfunkt - liest die durch Beistrich getrennten Parameter aus
;(Etwas bld gemacht mit 2 mal derselben Schleife, aber bei diesem Contest muss man ja nicht Code sparen ;-) )
Function GetParameter(txt$)
	Local temp$="",char$
	script_para_count=0
	For i=1 To Len(txt$)
		char$=Mid(txt$,i,1)
		If char$="," Then
			script_para_count=script_para_count+1
		EndIf
	Next
	Dim script_para(script_para_count)
	script_para_count=0
	For i=1 To Len(txt$)
		char$=Mid(txt$,i,1)
		If char$="," Then
			script_para(script_para_count)=temp$
			script_para_count=script_para_count+1
			temp$=""
		Else
			temp$=temp$+char$
		EndIf
	Next
	script_para(script_para_count)=temp$
	script_para_count=script_para_count+1
End Function

;Simulation (Zeichnen / Steuern)
Function DoSimu()
	Local popup=-1
	Local x,y
	
	;Zeichnen
	For x=0 To map_w
		For y=0 To map_h
			If map(x,y)<>Null Then
				DrawBlock map(x,y)\img,x*tile_w,y*tile_h
				If ctrl_mx>x*tile_w And ctrl_mx<(x+1)*tile_w Then
					If ctrl_my>y*tile_h And ctrl_my<(y+1)*tile_h Then
						Color 200,0,0
						Rect x*tile_w,y*tile_h,tile_w,tile_h,0
						popup=map(x,y)\operation
					EndIf
				EndIf
			EndIf
		Next
	Next
	Color 128,128,128
	Rect 0,0,(map_w+1)*tile_w,(map_h+1)*tile_h,0
	If popup<>-1 Then
		ShowPopup(popup)
	EndIf
	Color 255,255,255
	For i=0 To map_h
		Text 5,i*tile_h+5,Chr(i+97)
	Next
	
	;Maus-Abfrage
	x=ctrl_mx/tile_w
	y=ctrl_my/tile_h
	If ctrl_mhit Then
		If x=0 And y<=map_h Then
			state(x,y)=Not state(x,y)
		EndIf
	EndIf
	
	;Buttons
	If Button(gfx_w-150,50,"Zum Editor") Or escape Then
		gamemode=MODE_EDITOR
	EndIf
End Function

;Gesamter Editor (Zeichnen / Steuern)
Function DoEditor()
	Local popup=-1
	Local x,y
	Local zscroll
	
	;Zeichnen & bearbeiten
	For x=0 To map_w
		For y=0 To map_h
			If map(x,y)<>Null Then
				DrawBlock map(x,y)\img,x*tile_w,y*tile_h
				If ctrl_mx>x*tile_w And ctrl_mx<(x+1)*tile_w Then
					If ctrl_my>y*tile_h And ctrl_my<(y+1)*tile_h Then
						popup=map(x,y)\operation
						
						If ctrl_mhit Then
							map(x,y)=editor_selected
						EndIf
						If del Or ctrl_mhit2 Then
							map(x,y)=Null
						EndIf
					EndIf
				EndIf
			EndIf
		Next
	Next
	
	;Maus-Abfrage (Koordinaten)
	x=ctrl_mx/tile_w
	y=ctrl_my/tile_h
	If x<=map_w Then
		DrawBlock editor_selected\img,x*tile_w,y*tile_h
		Color 200,0,0
		Rect x*tile_w,y*tile_h,tile_w,tile_h,0
	EndIf
	Color 255,255,255
	For i=0 To map_h
		Text 5,i*tile_h+5,Chr(i+97)
	Next
	
	If ctrl_mhit Then
		If x>=1 And x<=map_w And y<=map_h Then
			map(x,y)=editor_selected
		EndIf
	EndIf
	If KeyHit(211) Or MouseHit(2) Then
		If x>=1 And x<map_w And y<map_h Then
			map(x,y)=Null
		EndIf
	EndIf
	
	;Maus-Abfrage (Mausrad)
	zscroll=MouseZSpeed()
	If zscroll>0 Then
		editor_selected=Before editor_selected
		If editor_selected=Null Then editor_selected=Last part
	EndIf
	If zscroll<0 Then
		editor_selected=After editor_selected
		If editor_selected=Null Then editor_selected=First part
	EndIf
	
	;Tile-Auswahl
	Local part.part
	x=gfx_w-tile_w*2.7
	y=220
	For part=Each part
		DrawBlock part\img,x,y
		If part=editor_selected Then
			Color 200,0,0
			Rect x,y,tile_w,tile_h,0
		EndIf
		If ctrl_mx>x And ctrl_mx<(x+tile_w) Then
			If ctrl_my>y And ctrl_my<(y+tile_h) Then
				popup=part\operation
				If ctrl_mhit Then
					editor_selected=part
				EndIf
			EndIf
		EndIf
		x=x+tile_w
		If x>gfx_w-tile_w Then
			x=gfx_w-tile_w*2.7
			y=y+tile_h
		EndIf
	Next
	
	Color 128,128,128
	Rect 0,0,(map_w+1)*tile_w,(map_h+1)*tile_h,0
	Rect 0,0,tile_w,(map_h+1)*tile_h,0
	Rect gfx_w-tile_w*2.7,220,tile_w*2,tile_h*6,0
	
	If popup<>-1 Then
		ShowPopup(popup)
	EndIf
	
	;Buttons
	Color 255,255,255
	If Button(gfx_w-150,20,"Neu") Then
		Editor_SetupMap()
	EndIf
	If Button(gfx_w-150,60,"Speichern") Then
		FilemenuSetup()
		gamemode=MODE_SAVE
	EndIf
	If Button(gfx_w-150,100,"Laden") Then
		FilemenuSetup()
		gamemode=MODE_LOAD
	EndIf
	If Button(gfx_w-150,140,"Simulieren!") Or escape Then
		gamemode=MODE_SIMU
	EndIf
	If Button(gfx_w-150,180,"Zum Men") Or escape Then
		MenuSetup()
		gamemode=MODE_MENU
	EndIf
End Function

Function Editor_SetupMap()
	Local x,y
	;Map zurck setzen
	For x=0 To map_w
		For y=0 To map_h
			If x=0 Then
				map(x,y)=firstpart
			Else
				map(x,y)=Null
			EndIf
		Next
	Next
End Function

;Hilfs-Einblendung ber Tile
Function ShowPopup(operation)
	Local w=200
	Local h=25
	Local x=ctrl_mx
	Local y=ctrl_my+20
	If x>gfx_w-w Then x=gfx_w-w
	If y>gfx_h-h Then y=gfx_h-h
	Color 0,0,0
	Rect x,y,w,h,1
	Color 255,255,255
	Rect x,y,w,h,0
	Text x+5,y+5,OP_NAMES$(operation)
End Function

Function FilemenuSetup()
	Local f.file
	Delete Each file
	If FileType("saves")<>2 Then
		CreateDir("saves")
	EndIf
	Local dir=ReadDir("saves")
	If dir=0 Then
		RuntimeError("Kann Ordner 'saves' nicht lesen")
	EndIf
	Local file$
	Repeat
		file$=NextFile(dir)
		If file$="" Then Exit
		If Right(file$,4)=".sav" Then
			f=New file
			f\name$=file$
		EndIf
	Forever
	CloseDir dir
End Function

;Laden-Dialog
Function DoMenuLoad()
	Local file.file
	Local y=60
	;File-Liste
	For file=Each file
		If Button(50,y,file\name$,200) Then
			LoadMap(file\name$)
			gamemode=MODE_EDITOR
		EndIf
		If Button(260,y,"(lschen)") Then
			DeleteFile "saves\"+file\name$
			FilemenuSetup()
		EndIf
		y=y+30
	Next
	If Button(gfx_w-220,gfx_h-45,"Zurck zum Editor",200) Then
		gamemode=MODE_EDITOR
	EndIf
	Text 50,30,"Whle eine Schaltung, die du laden mchtest:"
End Function

;Speichern-Dialog
Function DoMenuSave()
	Local file.file
	Local y=60
	;File-Liste
	For file=Each file
		If Button(50,y,file\name$,200) Then
			SaveMap(file\name$)
			gamemode=MODE_EDITOR
		EndIf
		If Button(260,y,"(lschen)") Then
			DeleteFile "saves\"+file\name$
			FilemenuSetup()
		EndIf
		y=y+30
	Next
	If Button(gfx_w-220,gfx_h-45,"Zurck zum Editor",200) Then
		gamemode=MODE_EDITOR
	EndIf
	;Beschreibung + Eigener Name
	Text 50,30,"Whle eine Schaltung, die du berschreiben mchtest:"
	Text 50,gfx_h-70,"Oder gib hier einen neuen Namen ein: "+savename$
	If Button(50,gfx_h-45,"Speichern",200) Then
		SaveMap(savename$)
		gamemode=MODE_EDITOR
	EndIf
	
	;Tastatureingabe
	Local key=GetKey()
	If key>=32 Then
		savename$=savename$+Chr(key)
	EndIf
	If key=13 Then
		SaveMap(savename$)
		gamemode=MODE_EDITOR
	EndIf
	If key=8 Then
		If Len(savename$)>0 Then
			savename$=Left(savename$,Len(savename$)-1)
		EndIf
	EndIf
End Function

;Map Speichern
Function SaveMap(file$)
	Local x,y
	If Right(file$,4)<>".sav" Then file$=file$+".sav"
	Local writer=WriteFile("saves\"+file$)
	If writer=0 Then
		RuntimeError("Konnte 'saves\"+file$+"' nicht schreiben")
	EndIf
	WriteByte(writer,tile_w)
	WriteByte(writer,tile_h)
	For x=0 To map_w
		For y=0 To map_h
			If map(x,y)=Null Then
				WriteString(writer,"")
			Else
				WriteString(writer,map(x,y)\script$)
			EndIf
		Next
	Next
	CloseFile writer
End Function

;Map Laden
Function LoadMap(file$)
	Local x,y
	If Right(file$,4)<>".sav" Then file$=file$+".sav"
	Local reader=ReadFile("saves\"+file$)
	If reader=0 Then
		RuntimeError("Kann 'saves\"+file$+"' nicht laden")
	EndIf
	tile_w=ReadByte(reader)
	tile_h=ReadByte(reader)
	map_w=(gfx_w-200)/tile_w-1
	map_h=gfx_h/tile_h-1
	Dim map.part(map_w,map_h)
	Dim state(map_w,map_h)
	Dim visited(map_w,map_h)
	Local txt$,p.part
	For x=0 To map_w
		For y=0 To map_h
			txt$=ReadString(reader)
			If txt$<>"" Then
				For p.part=Each part
					If p\script$=txt$ Then
						map(x,y)=p
						Exit
					EndIf
				Next
			EndIf
		Next
	Next
	CloseFile reader
End Function

;Simulation berechnen / ablaufen lassen
Function UpdateSimulation()
	Local x,y
	For x=0 To map_w
		For y=0 To map_h
			visited(x,y)=0
		Next
	Next
	;Von den Eingngen aus alle Leiter verfolgen bis zu einem OP (oder leeres Tile)
	For y=0 To map_h
		x=0
		FollowWire(x,y,DIR_RIGHT,state(x,y))
	Next
End Function

;Rekursiv einem normalen Leiter folgen
Function FollowWire(x,y,dir,val)
	If x<0 Or y<0 Or x>map_w Or y>map_h Then Return
	If map(x,y)=Null Then Return
	If visited(x,y)=1 And map(x,y)\directions<>0 Then Return
	visited(x,y)=1
	dir=InvertDirection(dir)
	Local move
	
	If map(x,y)\operation<>OP_NONE Then
		;Wir sind bei einer Operation!
		;Aktuellen Status ermitteln
		Select map(x,y)\operation
			Case OP_AND
				val=state(x,y-1) And state(x,y+1)
			Case OP_OR
				val=state(x,y-1) Or state(x,y+1)
			Case OP_NOT
				val=Not state(x-1,y)
			Case OP_XOR
				val=state(x,y-1) Xor state(x,y+1)
		End Select
		state(x,y)=val
		;Leiter am Output verfolgen bis zum nchsten OP (oder leeres Tile)
		FollowWire(x+1,y,DIR_RIGHT,val)
	Else
		;"eingehende Bewegung" erlaubt?
		move=map(x,y)\directions And (1 Shl dir)
		If move<>0 Then
			state(x,y)=val
			
			;alle anderen Richtungen ermitteln
			For i=1 To 4
				If i<>dir Then
					move=map(x,y)\directions And (1 Shl i)
					If move<>0 Then
						Select i
							Case DIR_RIGHT
								FollowWire(x+1,y,i,val)
							Case DIR_LEFT
								FollowWire(x-1,y,i,val)
							Case DIR_UP
								FollowWire(x,y-1,i,val)
							Case DIR_DOWN
								FollowWire(x,y+1,i,val)
						End Select
					EndIf
				EndIf
			Next
		EndIf
		;Sonderfall fr berkreuzung
		If map(x,y)\directions=0 Then
			state(x,y)=val
			dir=InvertDirection(dir)
			;jeweils senkrecht / waagrecht "einfach weiter leiten"
			Select dir
				Case DIR_RIGHT
					FollowWire(x+1,y,dir,val)
				Case DIR_LEFT
					FollowWire(x-1,y,dir,val)
				Case DIR_UP
					FollowWire(x,y-1,dir,val)
				Case DIR_DOWN
					FollowWire(x,y+1,dir,val)
			End Select
		EndIf
	EndIf
	Color (1-val)*255,(val)*255,0
	Rect x*tile_w,y*tile_h,tile_w,tile_h,0
	Color 255,255,255
End Function

;Gibt die jeweils entgegen gesetzte Richtung zurck
Function InvertDirection(dir)
	Select dir
		Case DIR_RIGHT
			Return DIR_LEFT
		Case DIR_LEFT
			Return DIR_RIGHT
		Case DIR_UP
			Return DIR_DOWN
		Case DIR_DOWN
			Return DIR_UP
	End Select
	Return 0
End Function

;~IDEal Editor Parameters:
;~F#28#57#5F#7F#89#98#AE#BD#125#13F#16C#1E1#1F0#1FE#215#22B#256#26C#28C#29B
;~F#2E3
;~C#Blitz3D