
	'______________________________________________________________________
	'In diesem Codeabschnitt passiert nichts aufregendes, er dient als Schnittstelle dazu,
	'die einzelnen Bestandteile einzubinden, bestimmte Daten und Berechnungsfunktionen
	'zu definieren und sonstige, meist grafische Einstellungen vorzunehmen.
	'______________________________________________________________________

	

'______________________________________________________________________
Const TonAnzahl:Int = 17  '"konstant" ist hier bitte ernst zu nehmen und NICHT mehr zu aendern!
'______________________________________________________________________
'Wichtige Definitionen fuer die Notation, Quantisierungen, die in Sechzehntel, Achtel oder Viertel erlaubt sein soll.
Const MaximalTaktAnzahl:Int = 4
Global MaximalNotenwert:Int, Schlaege_pro_Minute:Int = 60
		'die laengste Dauer, die eine Note haben darf, denn Ueberbindungen sind nicht vorgesehen.
Global MaximalDauer:Int   'alle Melodien seien auf acht Takte begrenzt
		'die Gesamtdauer der vorgegebenen Taktanzahl in Millisekunden
Global Viertel_pro_Takt:Int = 4 'bitte nur zwei,  drei, vier oder fnf ermglichen (Sonderfall 6/8-Takt?)
Global Quantisierung:Int[6] 'diesbezueglich verschiedene Daten:
Quantisierung[0] = 8	'Welcher MinimalNotenwert zugrundegelegt wird (16 = Sechzehntel, 8 = Achtel, 4 = Viertel)
Quantisierungsdaten_anpassen()
Quantisierung[5] = Quantisierung[3]		'Memo-Sechzehntel (fuer Tempowechsel notwendig)
Function Quantisierungsdaten_anpassen()
	Quantisierung[4] = (60000 / Schlaege_pro_Minute) 'die Dauer in Millisekunden, die dem Viertelwert zugestanden wird (=>Tempo)
	If Quantisierung[0] = 16 Then '1/16
		Quantisierung[1] = Quantisierung[4]/4	'die Dauer in Millisekunden, die dem MinimalNotenwert Quantisierung[0] zugestanden wird.
		Quantisierung[3] = Quantisierung[1]		'Sechzehntel
	ElseIf Quantisierung[0] = 8 Then '1/8
		Quantisierung[1] = Quantisierung[4]/2
		Quantisierung[3] = Quantisierung[1] / 2 's.o.
	Else 'Quantisierung[0] = 4 Then '1/4
		Quantisierung[1] = Quantisierung[4]
		Quantisierung[3] = Quantisierung[1] / 4
	End If
	Quantisierung[2] = Quantisierung[1]/2 'halber MinimalNotenwert (wird haeufig benutzt, darum...)
	MaximalNotenwert = Viertel_pro_Takt * Quantisierung[4]
	MaximalDauer = Quantisierung[3] * 4 * Viertel_pro_Takt * MaximalTaktAnzahl
End Function

'---------------------------------------------------------------------------------
'Bestimmte Tondauern bzw. Notenwerte lassen sich nicht einfach, sondern nur durch Doppelpunktierungen oder
'Ueberbindungen darstellen, was den Rahmen dieses Programm sprengen wuerde und nicht umgesetzt werden soll, 
'also sind verboten 5, 7, 9, 10, 11, 13, 14, 15, 17, 18, 19 und 20 Sechzehntel bzw. deren Entsprechungen in Achtel oder Viertel
Global DauerZensur:Int[] = [0,0,0,0,0,1,0,1,0,1,1,1,0,1,1,1,0,1,1,1,1] '(ja oder nein fuer 1 bis 20 Sechzehntel)
'Und - welcher (quantisierte) Sechzehntel-Notenwert wird von welchem Frame des Notenbilds dargestellt:
'(nix, 1/16, 1/8, p1/8, 1/4, nix, p1/4, nix, 1/2, nix, nix, nix, p1/2, nix, nix, nix, 1/1, nix, nix, nix, nix)
Global NotenkopfIndizes:Int[] = [0,0,0,1,0,0,1,1,2,2,2,2,3,3,3,3,4,4,4,4,4]
Global NotenhalsIndizes:Int[] = [1,1,2,2,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0]
Global Taktstrich_x:Int[]

'______________________________________________________________________
'Initialisierung der Grafik u.a.:
AppTitle = "Musiktrainer"
Graphics 1024, 600
SetBlend ALPHABLEND
SetClsColor 16,16,32
SetMaskColor 255,0,255

Local Hintergrund:TImage = LoadImage("Medien/Bilder/Hintergrund.png") 'hier ist vieles schon drauf...
Global Timer:TTimer = CreateTimer(60)
Global AktuelleZeit:Int 'damit pro (Haupt-)schleifendurchgang nur einmal 'Millisecs' notwendig ist.

'______________________________________________________________________
'Integration der notwendigen Klassen und Funktionen:
Include "Interaktion.bmx"
Include "TKlaviertaste.bmx"
Include "TPC_Taste.bmx"
Include "TTon.bmx"
Include "TNote.bmx"
Include "TPause.bmx"
Include "TMelodie.bmx"
Include "Menufunktionen.bmx"
Include "Demo_Note().bmx"
Include "TSkaliertesTextfeld.bmx"
Include "Animation.bmx"
'______________________________________________________________________
'Zur besseren Orientierung werden die folgenden Daten oft benutzt:
Global Noten_Name:String[]
Global EnharmonikIndex:Int = 0
Global Enharmonik:String[] = ["C-Dur", "c-Moll", "Des-Dur", "cis-Moll", "D-Dur", "d-Moll", "Es-Dur", "es-Moll", "E-Dur", "e-Moll", "F-Dur", "f-Moll", "Fis-Dur", "fis-Moll", "Ges-Dur", "es-Moll", "G-Dur", "g-Moll", "As-Dur", "as-Moll", "A-Dur", "a-Moll", "B-Dur", "b-Moll", "H-Dur", "h-Moll"]

Noten_Namen_definieren()
Function Noten_Namen_definieren()
	'Die folgende Festlegung trifft wohl nicht immer zu, aber meistens,
	'weil sich die wichtigsten alterierten Akkorde bilden lassen, z.B. s, Dv und DDv
	If Enharmonik[EnharmonikIndex] = "C-Dur" Or Enharmonik[EnharmonikIndex] = "g-Moll" Then
		Noten_Name = ["c", "cis", "d", "es", "e", "f", "fis", "g", "as", "a", "b", "h"]
		Demo_Note_y = [370, 370, 366, 363, 363, 359, 359, 356, 352, 352, 349, 349, 345, 345, 342, 338, 338, 335]
		Demo_Note_Vorzeichen = [0,1,0,2,0,0,1,0,2,0,2,0,0,1,0,2,0,0]
	ElseIf Enharmonik[EnharmonikIndex] = "G-Dur" Or Enharmonik[EnharmonikIndex] = "d-Moll" Then
		Noten_Name = ["c", "cis", "d", "es", "e", "f", "fis", "g", "gis", "a", "b", "h"]
		Demo_Note_y = [370, 370, 366, 363, 363, 359, 359, 356, 356, 352, 349, 349, 345, 345, 342, 338, 338, 335]
		Demo_Note_Vorzeichen = [0,1,0,2,0,0,1,0,1,0,2,0,0,1,0,2,0,0]	
	ElseIf Enharmonik[EnharmonikIndex] = "D-Dur" Or Enharmonik[EnharmonikIndex] = "a-Moll" Then
		Noten_Name = ["c", "cis", "d", "dis", "e", "f", "fis", "g", "gis", "a", "b", "h"]
		Demo_Note_y = [370, 370, 366, 366, 363, 359, 359, 356, 356, 352, 349, 349, 345, 345, 342, 342, 338, 335]
		Demo_Note_Vorzeichen = [0,1,0,1,0,0,1,0,1,0,2,0,0,1,0,1,0,0]
	ElseIf Enharmonik[EnharmonikIndex] = "A-Dur" Or Enharmonik[EnharmonikIndex] = "e-Moll" Then
		Noten_Name = ["c", "cis", "d", "dis", "e", "f", "fis", "g", "gis", "a", "ais", "h"]
		Demo_Note_y = [370, 370, 366, 366, 363, 359, 359, 356, 356, 352, 352, 349, 345, 345, 342, 342, 338, 335]
		Demo_Note_Vorzeichen = [0,1,0,1,0,0,1,0,1,0,1,0,0,1,0,1,0,0]
	ElseIf Enharmonik[EnharmonikIndex] = "E-Dur" Or Enharmonik[EnharmonikIndex] = "h-Moll" Then
		Noten_Name = ["c", "cis", "d", "dis", "e", "eis", "fis", "g", "gis", "a", "ais", "h"]
		Demo_Note_y = [370, 370, 366, 366, 363, 363, 359, 356, 356, 352, 352, 349, 345, 345, 342, 342, 338, 338]
		Demo_Note_Vorzeichen = [0,1,0,1,0,1,1,0,1,0,1,0,0,1,0,1,0,1]
	ElseIf Enharmonik[EnharmonikIndex] = "H-Dur" Or Enharmonik[EnharmonikIndex] = "fis-Moll" Then
		Noten_Name = ["his", "cis", "d", "dis", "e", "eis", "fis", "g", "gis", "a", "ais", "h"]
		Demo_Note_y = [373, 370, 366, 366, 363, 363, 359, 356, 356, 352, 352, 349, 349, 345, 342, 342, 338, 338]
		Demo_Note_Vorzeichen = [1,1,0,1,0,1,1,0,1,0,1,0,1,1,0,1,0,1]
	ElseIf Enharmonik[EnharmonikIndex] = "Fis-Dur" Or Enharmonik[EnharmonikIndex] = "cis-Moll" Then
		Noten_Name = ["his", "cis", "d", "dis", "e", "eis", "fis", "fisis", "gis", "a", "ais", "h"]
		Demo_Note_y = [373, 370, 366, 366, 363, 363, 359, 359, 356, 352, 352, 349, 349, 345, 342, 342, 338, 338]
		Demo_Note_Vorzeichen = [1,1,0,1,0,1,1,3,1,0,1,0,1,1,0,1,0,1]
	ElseIf Enharmonik[EnharmonikIndex] = "Ges-Dur" Then   'des-Moll ist unueblich
		Noten_Name = ["c", "des", "eses", "es", "fes", "f", "ges", "g", "as", "heses", "b", "ces"]
		Demo_Note_y = [370, 366, 363, 363, 359, 359, 356, 356, 352, 349, 349, 345, 345, 342, 338, 338, 335, 335]
		Demo_Note_Vorzeichen = [0,2,4,2,2,0,2,0,2,4,2,2,0,2,4,2,2,0]
	ElseIf Enharmonik[EnharmonikIndex] = "Des-Dur" Or Enharmonik[EnharmonikIndex] = "as-Moll" Then
		Noten_Name = ["c", "des", "d", "es", "fes", "f", "ges", "g", "as", "heses", "b", "ces"]
		Demo_Note_y = [370, 366, 366, 363, 359, 359, 356, 356, 352, 349, 349, 345, 345, 342, 342, 338, 335, 335]
		Demo_Note_Vorzeichen = [0,2,0,2,2,0,2,0,2,4,2,2,0,2,0,2,2,0]
	ElseIf Enharmonik[EnharmonikIndex] = "As-Dur" Or Enharmonik[EnharmonikIndex] = "es-Moll" Then
		Noten_Name = ["c", "des", "d", "es", "fes", "f", "ges", "g", "as", "a", "b", "ces"]
		Demo_Note_y = [370, 366, 366, 363, 359, 359, 356, 356, 352, 352, 349, 345, 345, 342, 342, 338, 335, 335]
		Demo_Note_Vorzeichen = [0,2,0,2,2,0,2,0,2,0,2,2,0,2,0,2,2,0]
	ElseIf Enharmonik[EnharmonikIndex] = "Es-Dur" Or Enharmonik[EnharmonikIndex] = "b-Moll" Then
		Noten_Name = ["c", "des", "d", "es", "e", "f", "ges", "g", "as", "a", "b", "ces"]
		Demo_Note_y = [370, 366, 366, 363, 363, 359, 356, 356, 352, 352, 349, 345, 345, 342, 342, 338, 338, 335]
		Demo_Note_Vorzeichen = [0,2,0,2,0,0,2,0,2,0,2,2,0,2,0,2,0,0]
	ElseIf Enharmonik[EnharmonikIndex] = "B-Dur" Or Enharmonik[EnharmonikIndex] = "f-Moll" Then
		Noten_Name = ["c", "des", "d", "es", "e", "f", "ges", "g", "as", "a", "b", "h"]
		Demo_Note_y = [370, 366, 366, 363, 363, 359, 356, 356, 352, 352, 349, 349, 345, 342, 342, 338, 338, 335]
		Demo_Note_Vorzeichen = [0,2,0,2,0,0,2,0,2,0,2,0,0,2,0,2,0,0]
	ElseIf Enharmonik[EnharmonikIndex] = "F-Dur" Or Enharmonik[EnharmonikIndex] = "c-Moll" Then
		Noten_Name = ["c", "des", "d", "es", "e", "f", "fis", "g", "as", "a", "b", "h"]
		Demo_Note_y = [370, 366, 366, 363, 363, 359, 359, 356, 352, 352, 349, 349, 345, 342, 342, 338, 338, 335]
		Demo_Note_Vorzeichen = [0,2,0,2,0,0,1,0,2,0,2,0,0,2,0,2,0,0]
	End If
End Function

'______________________________________________________________________