

	'______________________________________________________________________
	'TMelodie ist die wichtigste Klasse des Programms. Mit ihr werden vor allem
	'Objekte der Klasse TNote gesammelt und verwaltet.
	'______________________________________________________________________



Global MetronomSignal:TImage = LoadImage("Medien/Bilder/MetronomSignal.png")
Global Klick:TSound = LoadSound("Medien/Klaenge/Klick.ogg")
Global Vorzaehler:TSound[5]
For Local vz:Int = 0 To 4
	Vorzaehler[vz] = LoadSound("Medien/Klaenge/" + vz + ".ogg")
Next
Global Stimme:TMelodie[2]
Stimme[0] = TMelodie.erschaffen(134)
Stimme[1] = TMelodie.erschaffen(214)


Type TMelodie
	'----------------------------------------------------------------------
	Field Notenliste:TList, StartZeit:Int, MetronomSchlag:Int, MetronomZeit:Int
	Field Modus:Byte '(0 = inaktiv, 1 = aufnehmen, 2 = abspielen)
	Field c1_y:Int, Pausenliste:TList, Instrument:Int, Kanal:TChannel[TonAnzahl+1]
	'=======================================
	Function erschaffen:TMelodie(c1_y:Int)
		Local Melodie:TMelodie = New TMelodie
		Melodie.c1_y = c1_y   'die vertikale Position des eingestrichenen c als Orientierung fuer alle anderen Noten
		Melodie.Notenliste = CreateList()
		Melodie.Pausenliste = CreateList()
		Return Melodie
	End Function
	'=======================================
	Method verwenden()
		'=======
		zeichnen()
		'=======
		If Modus = 1 Then		'aufnehmen
			'------------------------------------
			Local vergangene_Zeit:Int = AktuelleZeit - StartZeit
			'-------------------------------------
			If MetronomSchlag >= Viertel_pro_Takt Then
				'-------------------------------------
				Local MetronomValue:Float = 1.0 * (AktuelleZeit - MetronomZeit) / Quantisierung[4]
				'-------------------------------------
				SetBlend LIGHTBLEND
				SetAlpha 1 - (AktuelleZeit - MetronomZeit) / 250.0
				DrawImage MetronomSignal, 266, 183
				SetAlpha 1
				SetBlend ALPHABLEND				
				'-------------------------------------
				If MetronomValue >= 1 Then 'solange dauert derzeit die Viertel
					MetronomSchlag = MetronomSchlag + 1
					Local KlickKanal:TChannel = CueSound(Klick)
					SetChannelVolume(KlickKanal, Klangvolumen/100.0)
					ResumeChannel(KlickKanal)
					MetronomZeit = AktuelleZeit
				End If
				'-------------------------------------
				'erzwungenes Ende nach acht Takten:
				If vergangene_Zeit > MaximalDauer Then
					aufnehmen_stoppen()
					Return
				End If
				'-------------------------------------
				For Local t:Int = 0 To TonAnzahl
					'-------------------------------------
					'Eingaben von der Klaviertastatur aufnehmen:
					If Klaviertaste[t].angeschlagen = 1 Then
						Local Neue_Note:TNote = TNote.aufnehmen(t, 0, vergangene_Zeit, c1_y)
						If Neue_Note <> Null Then ListAddFirst(Notenliste, Neue_Note)
						'diese Reihenfolge ''first'' ist wichtig fuer das folgende
						'Zuordnen des ''Loslassens'' zur richtigen Note in der Liste:
					ElseIf Klaviertaste[t].angeschlagen = -1 Then
						For Local Note:TNote = EachIn Notenliste
							If Note.Index = t And Note.Aufnahmequelle = 0 Then 'das muss die letzte dazu passende sein!
								Note.Dauer_feststellen(vergangene_Zeit)
								Exit
							End If
						Next
					ElseIf Klaviertaste[t].angeschlagen = 2 Then
						For Local Note:TNote = EachIn Notenliste
							If Note.Index = t And Note.Aufnahmequelle = 0 Then
								SetColor 255,96,0
								Note.Note_zeichnen()
								SetColor 255,255,255
								Exit
							End If
						Next						
					End If
					'-------------------------------------
					'Eingaben von der PC-Tastatur aufnehmen:
					If PC_Taste[t].angeschlagen = 1 Then
						Local Neue_Note:TNote = TNote.aufnehmen(t, 1, vergangene_Zeit, c1_y)
						If Neue_Note <> Null Then ListAddFirst(Notenliste, Neue_Note)
					ElseIf PC_Taste[t].angeschlagen = -1 Then
						For Local Note:TNote = EachIn Notenliste
							If Note.Index = t And Note.Aufnahmequelle = 1 Then
								Note.Dauer_feststellen(vergangene_Zeit)
								Exit
							End If
						Next
					ElseIf PC_Taste[t].angeschlagen = 2 Then
						For Local Note:TNote = EachIn Notenliste
							If Note.Index = t And Note.Aufnahmequelle = 1 Then
								SetColor 255,96,0
								Note.Note_zeichnen()
								SetColor 255,255,255
								Exit
							End If
						Next
					End If
					'-------------------------------------
				Next
			Else 'MetronomSchlag < Viertel_pro_Takt => Vorzaehler
				'-------------------------------------
				SetBlend LIGHTBLEND
				SetAlpha 1 - 1.0*vergangene_Zeit / 250.0
				DrawImage MetronomSignal, 266, 183
				SetAlpha 1
				SetBlend ALPHABLEND
				'-------------------------------------	
				If vergangene_Zeit >= Quantisierung[4] Then 'solange dauert derzeit die Viertel
					Local VorzaehlerKanal:TChannel = CueSound(Vorzaehler[MetronomSchlag])
					SetChannelVolume(VorzaehlerKanal, Klangvolumen/100.0)
					Local KlickKanal:TChannel = CueSound(Klick)
					SetChannelVolume(KlickKanal, Klangvolumen/100.0)
					ResumeChannel(VorzaehlerKanal)
					ResumeChannel(KlickKanal)
					MetronomSchlag = MetronomSchlag + 1
					If MetronomSchlag = Viertel_pro_Takt Then
						StartZeit = AktuelleZeit + Quantisierung[4]
						MetronomZeit = AktuelleZeit
					Else
						StartZeit = AktuelleZeit
					End If
				End If
			End If
			'_________________________________________________
		ElseIf Modus = 2 Then	'abspielen
			Local vergangene_Zeit:Int = AktuelleZeit - StartZeit
			If vergangene_Zeit > MaximalDauer Then
				abspielen_stoppen()
				Return
			End If
			For Local Note:TNote = EachIn Notenliste
				Note.abspielen(vergangene_Zeit, Instrument)
			Next
		End If
	End Method
	'=======================================
	Method aufnehmen_starten()
		If Modus = 1 Then
			aufnehmen_stoppen()
		ElseIf Modus = 2 Then
			abspielen_stoppen()
		End If
		Notenliste = CreateList()
		If Pausenliste <> Null Then ClearList(Pausenliste)
		Modus = 1   '(aufnehmen)
		Local VorzaehlerKanal:TChannel = CueSound(Vorzaehler[0])
		SetChannelVolume(VorzaehlerKanal, Klangvolumen/100.0)
		Local KlickKanal:TChannel = CueSound(Klick)
		SetChannelVolume(KlickKanal, Klangvolumen/100.0)
		ResumeChannel(VorzaehlerKanal)
		ResumeChannel(KlickKanal)
		MetronomSchlag = 1
		StartZeit = AktuelleZeit
	End Method
	'----------------------------------------------------------------------
	Method aufnehmen_stoppen()
		For Local Note:TNote = EachIn Notenliste   'noch nicht beendete Noten zwangsweise beenden!
			TTon.verstummen(Note.Index, Note.Kanal)
			If Note.ExakteDauer = 0 Then Note.Dauer_feststellen(AktuelleZeit - StartZeit)
		Next
		eventuelle_Pausen_fuellen()
		Vorzeichenwechsel_pro_Takt_formatieren()
		'diese Formatierungsreihenfolge ist wichtig!
		Fehler_bei_Akkorddarstellung_vermindern()
		Animations_Status = TMelodie.stimmen_die_Stimmen_ueberein()
		Modus = 0
	End Method
	'=======================================
	Method abspielen_starten()
		If Notenliste = Null Then Return
		If Modus = 1 Then
			aufnehmen_stoppen()
		ElseIf Modus = 2 Then
			abspielen_stoppen()
		End If
		Modus = 2   '(abspielen)
		StartZeit = AktuelleZeit
	End Method
	'----------------------------------------------------------------------
	Method abspielen_stoppen()
		Modus = 0   '(inaktiv)
		For Local Note:TNote = EachIn Notenliste
			TTon.verstummen(Note.Index, Note.Kanal)
			Note.aktiv = 0
		Next
	End Method
	'---------------------------------------------------------------------
	Method eventuelle_Pausen_fuellen() 'nur am Ende einer Aufnahme sollte genuegen...
		Pausenliste = CreateList()
		Local Klingt_an_dieser_Sechzehntelstelle_ein_Ton:Int[MaximalTaktAnzahl * Viertel_pro_Takt * 4+1]
		If Notenliste <> Null Then
			For Local Note:TNote = EachIn Notenliste
				Local z:Int = Note.QuantisierterStart 
				While z <= Note.QuantisierterStop
					Klingt_an_dieser_Sechzehntelstelle_ein_Ton[z/Quantisierung[3]] = True
					z = z + Quantisierung[3]
				Wend
			Next
		End If
		'-------
		Local Sechzehntel_pro_Takt:Int = 4*Viertel_pro_Takt
		Local s:Int = 0 
		While s < MaximalTaktAnzahl * Sechzehntel_pro_Takt
			If Klingt_an_dieser_Sechzehntelstelle_ein_Ton[s] = False Then
				Local Anzahl_leerer_Sechzehntel:Int = 1
				Local Rest_Sechzehntel_im_Takt:Int = Sechzehntel_pro_Takt - ((s + 1) Mod Sechzehntel_pro_Takt)
				While Rest_Sechzehntel_im_Takt > 0 And Klingt_an_dieser_Sechzehntelstelle_ein_Ton[s + Anzahl_leerer_Sechzehntel] = False '? And s + Anzahl_leerer_Sechzehntel =< MaximalTaktAnzahl * Viertel_pro_Takt * 4
					Anzahl_leerer_Sechzehntel = Anzahl_leerer_Sechzehntel + 1
					Rest_Sechzehntel_im_Takt = Rest_Sechzehntel_im_Takt - 1
				Wend
				Repeat
					If Anzahl_leerer_Sechzehntel >= 16 Then
						Local Pause:TPause = TPause.erschaffen(TNote.Sechzehntel_x_Position[s], c1_y, 4)
						ListAddLast(Pausenliste, Pause)
						s = s + 16
						Anzahl_leerer_Sechzehntel = Anzahl_leerer_Sechzehntel - 16
					ElseIf Anzahl_leerer_Sechzehntel >= 8 Then
						Local Pause:TPause = TPause.erschaffen(TNote.Sechzehntel_x_Position[s], c1_y, 3)
						ListAddLast(Pausenliste, Pause)
						s = s + 8
						Anzahl_leerer_Sechzehntel = Anzahl_leerer_Sechzehntel - 8
					ElseIf Anzahl_leerer_Sechzehntel >= 4 Then
						Local Pause:TPause = TPause.erschaffen(TNote.Sechzehntel_x_Position[s], c1_y, 2)
						ListAddLast(Pausenliste, Pause)
						s = s + 4
						Anzahl_leerer_Sechzehntel = Anzahl_leerer_Sechzehntel - 4
					ElseIf Anzahl_leerer_Sechzehntel >= 2 Then
						Local Pause:TPause = TPause.erschaffen(TNote.Sechzehntel_x_Position[s], c1_y, 1)
						ListAddLast(Pausenliste, Pause)
						s = s + 2
						Anzahl_leerer_Sechzehntel = Anzahl_leerer_Sechzehntel - 2
					Else   '(If Anzahl_leerer_Sechzehntel = 1 Then)
						Local Pause:TPause = TPause.erschaffen(TNote.Sechzehntel_x_Position[s], c1_y, 0)
						ListAddLast(Pausenliste, Pause)
						s = s + 1
						Anzahl_leerer_Sechzehntel = Anzahl_leerer_Sechzehntel - 1
					End If
				Until Anzahl_leerer_Sechzehntel = 0
			Else
				s = s + 1
			End If		
		Wend
		'-------
	End Method
	'---------------------------------------------------------------------
	Method Fehler_bei_Akkorddarstellung_vermindern()  '(wirklich behoben werden sie nicht)
		For Local Note1:TNote = EachIn Notenliste
			For Local Note2:TNote = EachIn Notenliste
				If Note1.Index <> Note2.Index And Note1.x = Note2.x Then
					If Note2.QuantisierterStart > Note1.QuantisierterStart Then
					'Bedenke: nach der Methode Vorzeichenwechsel_pro_Takt_formatieren()
					'sind die Noten chronologisch richtig aufgelistet
						Exit
					End If
					If Abs(Note1.y - Note2.y) < 6 Then 'weniger als Abstand zweier Notenlinien
						If Note2.VorzeichenbildIndex = 0 Then
							Note1.x = Note1.x - 7   'Note1 etwas nach links ruecken
							Note1.NotenhalsIndex = 0 'Hals entfernen
						ElseIf Note1.VorzeichenbildIndex = 0 Then
							Note2.x = Note2.x - 7   'Note2 etwas nach links ruecken
							Note2.NotenhalsIndex = 0  'Hals entfernen
						Else
							Note1.x = Note1.x + 6   'Note1 etwas nach rechts ruecken
							Note2.x = Note2.x - 6   'Note2 etwas nach links ruecken
						End If
					Else					
						'-----------------------------------------------------------------
						'Ansonsten mehrfache Notenhaelse in Akkorden vermeiden:
						If Note1.NotenhalsIndex > 0 And Note2.NotenhalsIndex > 0 Then
							If Note1.Index > Note2.Index Then
								If Note1.NotenhalsIndex >= 4 Then Note1.NotenhalsIndex = Note1.NotenhalsIndex - 3
								Note2.NotenhalsIndex = 3
							Else
								If Note2.NotenhalsIndex >= 4 Then Note2.NotenhalsIndex = Note2.NotenhalsIndex - 3
								Note1.NotenhalsIndex = 3
							End If
						End If
					End If						
				End If
			Next
		Next
	End Method
	'---------------------------------------------------------------------
	Method Vorzeichenwechsel_pro_Takt_formatieren()
		Local Zeit_pro_Takt:Int = Viertel_pro_Takt * Quantisierung[4]
		Local Notennamen_pro_Takt:TList = CreateList()
		ReverseList(Notenliste)
		For Local Note:TNote = EachIn Notenliste
			If Note.QuantisierterStart Mod Zeit_pro_Takt > 0 Then
				If Len(Noten_Name[Note.Index Mod 12]) = 1 Then 'nicht-alterierter Ton (ausser b)
					Select Noten_Name[Note.Index Mod 12]
					Case "c"   'falls vorher im Takt ein alteriertes c vorkam ...
						If ListContains(Notennamen_pro_Takt, "ces") Then
							Note.VorzeichenbildIndex = 5   'muss ein Aufloesungszeichen gesetzt werden!
							ListRemove(Notennamen_pro_Takt, "ces")
							ListAddLast(Notennamen_pro_Takt, "c")
						ElseIf ListContains(Notennamen_pro_Takt, "cis") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "cis")
							ListAddLast(Notennamen_pro_Takt, "c")
						End If
					Case "d"
						If ListContains(Notennamen_pro_Takt, "des") Then
							Note.VorzeichenbildIndex = 5   'muss ein Aufloesungszeichen gesetzt werden!
							ListRemove(Notennamen_pro_Takt, "des")
							ListAddLast(Notennamen_pro_Takt, "d")
						ElseIf ListContains(Notennamen_pro_Takt, "dis") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "dis")
							ListAddLast(Notennamen_pro_Takt, "d")
						End If
					Case "e"
						If ListContains(Notennamen_pro_Takt, "eses") Then
							Note.VorzeichenbildIndex = 5   'muss ein Aufloesungszeichen gesetzt werden!
							ListRemove(Notennamen_pro_Takt, "eses")
							ListAddLast(Notennamen_pro_Takt, "e")
						ElseIf ListContains(Notennamen_pro_Takt, "es") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "es")
							ListAddLast(Notennamen_pro_Takt, "e")
						ElseIf ListContains(Notennamen_pro_Takt, "eis") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "eis")
							ListAddLast(Notennamen_pro_Takt, "e")
						End If
					Case "f"
						If ListContains(Notennamen_pro_Takt, "fes") Then
							Note.VorzeichenbildIndex = 5   'muss ein Aufloesungszeichen gesetzt werden!
							ListRemove(Notennamen_pro_Takt, "fes")
							ListAddLast(Notennamen_pro_Takt, "f")
						ElseIf ListContains(Notennamen_pro_Takt, "fis") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "fis")
							ListAddLast(Notennamen_pro_Takt, "f")
						ElseIf ListContains(Notennamen_pro_Takt, "fisis") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "fisis")
							ListAddLast(Notennamen_pro_Takt, "f")
						End If
					Case "g"
						If ListContains(Notennamen_pro_Takt, "ges") Then
							Note.VorzeichenbildIndex = 5   'muss ein Aufloesungszeichen gesetzt werden!
							ListRemove(Notennamen_pro_Takt, "ges")
							ListAddLast(Notennamen_pro_Takt, "g")
						ElseIf ListContains(Notennamen_pro_Takt, "gis") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "gis")
							ListAddLast(Notennamen_pro_Takt, "g")
						End If
					Case "a"
						If ListContains(Notennamen_pro_Takt, "as") Then
							Note.VorzeichenbildIndex = 5   'muss ein Aufloesungszeichen gesetzt werden!
							ListRemove(Notennamen_pro_Takt, "as")
							ListAddLast(Notennamen_pro_Takt, "a")
						ElseIf ListContains(Notennamen_pro_Takt, "ais") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "ais")
							ListAddLast(Notennamen_pro_Takt, "a")
						End If
					Case "h"
						If ListContains(Notennamen_pro_Takt, "heses") Then
							Note.VorzeichenbildIndex = 5   'muss ein Aufloesungszeichen gesetzt werden!
							ListRemove(Notennamen_pro_Takt, "heses")
							ListAddLast(Notennamen_pro_Takt, "h")
						ElseIf ListContains(Notennamen_pro_Takt, "b") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "b")
							ListAddLast(Notennamen_pro_Takt, "h")
						ElseIf ListContains(Notennamen_pro_Takt, "his") Then
							Note.VorzeichenbildIndex = 5
							ListRemove(Notennamen_pro_Takt, "his")
							ListAddLast(Notennamen_pro_Takt, "h")
						End If
					Case "b"
						If ListContains(Notennamen_pro_Takt, "b") Then
							Note.VorzeichenbildIndex = 0   'kein weiteres Vorzeichen mehr notwendig
						Else
							ListAddLast(Notennamen_pro_Takt, "b")
						End If
					End Select				
				Else   'If Len(Noten_Name[Note.Index Mod 12]) > 1 Then 'alterierter Ton
					If ListContains(Notennamen_pro_Takt, Noten_Name[Note.Index Mod 12]) Then
						Note.VorzeichenbildIndex = 0   '(gar kein Vorzeichen mehr notwendig)
					Else
						ListAddLast(Notennamen_pro_Takt, Noten_Name[Note.Index Mod 12])
					End If
				End If
			Else
				ClearList(Notennamen_pro_Takt)
				ListAddLast(Notennamen_pro_Takt, Noten_Name[Note.Index Mod 12])
			End If
		Next
	End Method
	'---------------------------------------------------------------------
	Method zeichnen()
		SetColor 0,0,0
		For Local Note:TNote = EachIn Notenliste
			Note.Note_zeichnen()
		Next
		SetColor 255,255,255
		For Local Pause:TPause = EachIn Pausenliste
			Pause.zeichnen()
		Next
	End Method
	'=======================================
	Method Noten_an_neues_Tempo_anpassen()
		For Local Note:TNote = EachIn Notenliste
			Note.ExakteDauer = 1.0 * Note.ExakteDauer / Quantisierung[5] * Quantisierung[3]
			Note.ExakterStart = 1.0 * Note.ExakterStart / Quantisierung[5] * Quantisierung[3]
			Note.ExakterStop = 1.0 * Note.ExakterStop / Quantisierung[5] * Quantisierung[3]
			Note.QuantisierterStart = (Note.ExakterStart+Quantisierung[2]) / Quantisierung[1] * Quantisierung[1]
			Note.QuantisierteDauer = Min(MaximalNotenwert, Max(Quantisierung[1], (Note.ExakteDauer+Quantisierung[2]) / Quantisierung[1] * Quantisierung[1]))
			Local ZensurIndex:Int = Note.QuantisierteDauer/Quantisierung[3]
			While DauerZensur[ZensurIndex] = True
				ZensurIndex = ZensurIndex - 1
				Note.QuantisierteDauer = Note.QuantisierteDauer - Quantisierung[3]
			Wend
			Note.NotenkopfIndex = NotenkopfIndizes[ZensurIndex]
			Note.NotenhalsIndex = NotenhalsIndizes[ZensurIndex]
			If Note.Index > 11 And Note.NotenhalsIndex <> 0 Then Note.NotenhalsIndex = Note.NotenhalsIndex + 3   'nach unten!
			'die folgende quasi symbolische Differenz - 1 hat nur einen mathematisch-technischen
			'Grund in der Method eventuelle_Pausen_fuellen() von TMelodie
			Note.QuantisierterStop = Min(MaximalDauer-1, Note.QuantisierterStart + Note.QuantisierteDauer - 1)
			Note.x = TNote.Sechzehntel_x_Position[Note.QuantisierterStart / Quantisierung[3]]
		Next
	End Method
	'=======================================
	Method Alle_Noten_neu_quantisieren()
		For Local Note:TNote = EachIn Notenliste
			Note.QuantisierterStart = (Note.ExakterStart+Quantisierung[2]) / Quantisierung[1] * Quantisierung[1]
			Note.QuantisierteDauer = Min(MaximalNotenwert, Max(Quantisierung[1], (Note.ExakteDauer+Quantisierung[2]) / Quantisierung[1] * Quantisierung[1]))
			Local ZensurIndex:Int = Note.QuantisierteDauer/Quantisierung[3]
			While DauerZensur[ZensurIndex] = True
				ZensurIndex = ZensurIndex - 1
				Note.QuantisierteDauer = Note.QuantisierteDauer - Quantisierung[3]
			Wend
			Note.NotenkopfIndex = NotenkopfIndizes[ZensurIndex]
			Note.NotenhalsIndex = NotenhalsIndizes[ZensurIndex]
			If Note.Index > 11 And Note.NotenhalsIndex <> 0 Then Note.NotenhalsIndex = Note.NotenhalsIndex + 3   'nach unten!
			'die folgende quasi symbolische Differenz - 1 hat nur einen mathematisch-technischen
			'Grund in der Method eventuelle_Pausen_fuellen() von TMelodie
			Note.QuantisierterStop = Min(MaximalDauer-1, Note.QuantisierterStart + Note.QuantisierteDauer - 1)
			Note.x = TNote.Sechzehntel_x_Position[Note.QuantisierterStart / Quantisierung[3]]
		Next
		eventuelle_Pausen_fuellen()
	End Method
	'=======================================
	Method Alle_Noten_enharmonisch_umdeuten()
		For Local Note:TNote = EachIn Notenliste
			Note.y_und_Vorzeichen_berechnen(c1_y)
		Next
		ReverseList(Notenliste)
		Vorzeichenwechsel_pro_Takt_formatieren()
		'diese Formatierungsreihenfolge ist wichtig!
		Fehler_bei_Akkorddarstellung_vermindern()
	End Method
	'=======================================
	Function Taktstriche_malen()
		SetColor 0,0,0
		For Local ts:Int = 0 To MaximalTaktAnzahl
			DrawRect Taktstrich_x[ts], 100, 1, 28
			DrawRect Taktstrich_x[ts], 180, 1, 28
		Next
		SetColor 255,255,255
	End Function
	'=======================================
	Function stimmen_die_Stimmen_ueberein:Byte()
		Local Notenanzahl:Int[3]
		Notenanzahl[0] = CountList(Stimme[0].Notenliste)
		Notenanzahl[1] = CountList(Stimme[1].Notenliste)
		If Notenanzahl[0] < 8 Or Notenanzahl[1] < 8 Then Return False 'erst eine Melodie mit mindestens 8 Toenen sollte "belohnungswuerdig" werden!
		If Notenanzahl[0] <> Notenanzahl[1] Then Return False
		For Local Note_0:TNote = EachIn Stimme[0].Notenliste
			For Local Note_1:TNote = EachIn Stimme[1].Notenliste
				If Note_0.mit_anderer_Note_vergleichen(Note_1) = True Then
					Notenanzahl[2] = Notenanzahl[2] + 1
					Exit
				End If
			Next
		Next
		If Notenanzahl[0] <> Notenanzahl[2] Then Return False
		Return True
	End Function
	'=======================================
End Type
