
	'_________________________________________________________________________________
	'Hier findet man ein kleines Steuerelement, um mehrzeiligen, einfachen Text darzustellen, zu laden,
	'zu speichern und zu bearbeiten. Die Moeglichkeiten der Texteingabe und -manipulation
	'beschraenken sich auf die Eingabe und die Rueckstelltaste. Gezielte Auswahl von Textbausteinen
	'ist nicht moeglich. Statt Laufleisten oder Scrollbalken zu nutzen, skaliert das Objekt die Darstellung.
	'_________________________________________________________________________________



Global Schriftart:TImageFont = LoadImageFont("Medien/Schriftart/linux-truetypefonts/msttcorefonts/Arial (NICHT von Windows, kostenlos in ubuntu).ttf", 16)
SetImageFont Schriftart
Global SkaliertesTextfeld:TSkaliertesTextfeld = TSkaliertesTextfeld.erschaffen(16,8,1000,54)




Type TSkaliertesTextfeld

	Field x:Int, y:Float, Breite:Int, Tiefe:Int, y_Schritt:Float, Skalierung:Float, Feinjustierung:Float
	Field Zeilenliste:TList, LetzteZeile:String, TabulatorLeerzeichenAnzahl:Int, aktiv:Byte, AktivStartZeit:Int
	
	'===========================================================
	Function erschaffen:TSkaliertesTextfeld(x:Int, y:Int, Breite:Int, Tiefe:Int, Feinjustierung:Float = 0.05, TabulatorLeerzeichenAnzahl:Int = 8)
		Local NeuesTextFeld:TSkaliertesTextfeld = New TSkaliertesTextfeld
		NeuesTextFeld.x = x
		NeuesTextFeld.y = y
		NeuesTextFeld.Breite = Breite
		NeuesTextFeld.Tiefe = Tiefe
		NeuesTextFeld.Feinjustierung = Feinjustierung '(die Zoomschritte, die getestet werden, um den Text passend zu verkleinern)
		NeuesTextFeld.Skalierung = 1.0
		NeuesTextFeld.y_Schritt = TextHeight("|")
		NeuesTextFeld.Zeilenliste = CreateList()
		ListAddLast(NeuesTextFeld.Zeilenliste, "")  'mindestens eine (leere) Zeile sollte das Textfeld stets besitzen!
		NeuesTextFeld.TabulatorLeerzeichenAnzahl = TabulatorLeerzeichenAnzahl
		Return NeuesTextFeld
	End Function
	'===========================================================
	Method leeren()
		Skalierung = 1.0
		ClearList(Zeilenliste)
		LetzteZeile = ""
		ListAddLast(Zeilenliste, "")  'mindestens eine (leere) Zeile sollte das Textfeld stets besitzen!
	End Method
	'---------------------------------------------------------------------------------------------------------
	Method aktivieren()
		aktiv = True
		FlushKeys()
		AktivStartZeit = MilliSecs()
	End Method
	'---------------------------------------------------------------------------------------------------------
	Method deaktivieren()
		aktiv = False
		FlushKeys()
	End Method
	'---------------------------------------------------------------------------------------------------------
	Method Zeilenliste_laden(NeueZeilenliste:TList = Null)
		ClearList(Zeilenliste)
		If NeueZeilenliste = Null Or CountList(NeueZeilenliste) = 0 Then
			LetzteZeile = ""
			ListAddLast(Zeilenliste, LetzteZeile)
			Return				
		End If
		For LetzteZeile = EachIn NeueZeilenliste
			ListAddLast(Zeilenliste, LetzteZeile)
		Next
		If CountList(Zeilenliste) > 0 Then
			skalieren()
		End If
	End Method
	'---------------------------------------------------------------------------------------------------------
	Method Zeilenliste_komprimieren()
		Local komprimierte_Zeilenliste:TList = CreateList()
		Local ZusammengefassteZeile:String
		For LetzteZeile = EachIn Zeilenliste
			ZusammengefassteZeile = ZusammengefassteZeile + LetzteZeile
			If Asc(Right(LetzteZeile, 1)) = 13 Then
				ListAddLast(komprimierte_Zeilenliste, ZusammengefassteZeile)
				ZusammengefassteZeile = ""
			End If
		Next
		If Asc(Right(LetzteZeile, 1)) <> 13 Then	ListAddLast(komprimierte_Zeilenliste, ZusammengefassteZeile)
		ClearList(Zeilenliste)
		Zeilenliste = komprimierte_Zeilenliste
	End Method
	'---------------------------------------------------------------------------------------------------------
	Method TextLaden:Byte(DateiStrom:TStream)
		If DateiStrom = Null Then Return False
		ClearList(Zeilenliste)
		Local GeleseneZeile:String
		While Not Eof(DateiStrom)
			GeleseneZeile = ""
			Local Zeichen:String
			Repeat
				If Eof(DateiStrom) Then Exit
				Zeichen = ReadString(DateiStrom, 1)
				GeleseneZeile = GeleseneZeile + Zeichen
			Until Asc(Zeichen) = 13
			If GeleseneZeile <> "" Then ListAddLast(Zeilenliste, GeleseneZeile)
		Wend
		LetzteZeile = GeleseneZeile
		If CountList(Zeilenliste) > 0 Then
			skalieren()
		End If
		Return True
	End Method
	'---------------------------------------------------------------------------------------------------------
	Method TextSpeichern:Byte(DateiStrom:TStream)
		If DateiStrom = Null Then Return False
		For Local Zeile:String = EachIn Zeilenliste
			Local i:Int = 1
			While i <= Len(Zeile)
				WriteString(DateiStrom, Mid(Zeile,i,1))
				i = i + 1
			Wend
		Next
		Return True
	End Method
	'---------------------------------------------------------------------------------------------------------
	Method skalieren(SkalierungsStart:Float = 1.0) '(nicht vergroessern, nur ggfs. verkleinern)
		Skalierung = SkalierungsStart 
		Local Zeile:String, Reale_TextTiefe:Int
		Local KorrigierteZeilenListe:TList = CreateList()
		'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		Repeat
			ClearList(KorrigierteZeilenListe)
			For Local Zeile:String = EachIn Zeilenliste
				If Zeile <> "" Then
					While Zeile <> ""
						Local i:Int = 1
						While TextWidth(Left(Zeile, i)) <= Breite/Skalierung
							i = i + 1
							If i > Len(Zeile) Then Exit
						Wend
						If i < Len(Zeile)
							Local j:Int = i
							Repeat
								If Mid(Zeile, j, 1) = " " Or Mid(Zeile, j, 1) = "-" Then
									ListAddLast(KorrigierteZeilenListe, Left(Zeile, j))
									Zeile = Right(Zeile, Len(Zeile) - j)
									Exit
								ElseIf j = 0 Then
									ListAddLast(KorrigierteZeilenListe, Left(Zeile, j-1))
									Zeile = Right(Zeile, Len(Zeile) - j)
									Exit
								End If
								j = j - 1
							Forever
						Else
							ListAddLast(KorrigierteZeilenListe, Zeile)
							Exit
						End If
					Wend
				Else
					ListAddLast(KorrigierteZeilenListe, "")
				End If
			Next
			'------------------------------------
			y_Schritt = Skalierung * TextHeight(Zeile)
			Reale_TextTiefe = y_Schritt * CountList(KorrigierteZeilenListe)
			'------------------------------------
			If Tiefe >= Reale_TextTiefe Then  'DAS HIER ist das entscheidende Signal ...
				ClearList(Zeilenliste)
				For LetzteZeile = EachIn KorrigierteZeilenListe
					ListAddLast(Zeilenliste, LetzteZeile)
				Next
				Exit '... fuer den erfolgreichen Ausstieg aus der Testschleife
			End If
			'------------------------------------
			If Skalierung > Feinjustierung Then
				Skalierung = Skalierung - Feinjustierung
				'________________________________________
				'Falls der Text doch einmal SEHR gross sein sollte,
				'darf Skalierung nicht sofort = 0 sein, sonst waere 
				'der Text ja "verschwunden", also muessen trotz vor-
				'definierter Feinjustierung noch kleinere Schritte erlaubt sein:
			ElseIf Skalierung > Feinjustierung/2.0 Then
				Skalierung = Feinjustierung/2.0
			ElseIf Skalierung > Feinjustierung/4.0 Then
				Skalierung = Feinjustierung/4.0
			Else
				Skalierung = Skalierung - Feinjustierung/10.0
			End If
			'-----------------------------------
		Forever
		'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	End Method
	'---------------------------------------------------------------------------------------------------------
	Method verwenden()
		SetColor 0,0,0
		'------------
		SetScale Skalierung, Skalierung
		Local temp_y:Float = y
		'-----------
		If aktiv = True Then 'bereit zur (einfachen) Texteingabe und - Manipulation
			'--------------------------------------------
			For Local Zeile:String = EachIn Zeilenliste
				DrawText Zeile, x, temp_y
				temp_y = temp_y + y_Schritt
			Next
			If (MilliSecs() - AktivStartZeit) Mod 800 < 400 Then
				SetColor 255,125,0
				DrawRect x + Skalierung * TextWidth(LetzteZeile), temp_y - y_Schritt, 0.5*y_Schritt, y_Schritt
				SetColor 255,255,255
			End If
			'--------------------------------------------
			Local Ascii:Int = GetChar()
			If Ascii <> 0 Then
				If Ascii = 27 Then   'Escape
					deaktivieren()
					FlushKeys()
				Else
					ListRemove(Zeilenliste, LetzteZeile)
					If Ascii = 13 Then 	'Enter
						LetzteZeile = LetzteZeile + Chr(13)
						ListAddLast(Zeilenliste, LetzteZeile)
						LetzteZeile = ""
						ListAddLast(Zeilenliste, LetzteZeile)
						If CountList(Zeilenliste)*y_Schritt > Tiefe Then 'Unterhalb ist nicht mehr genug Platz fuer eine neue Zeile
							Zeilenliste_komprimieren()
							'------------------------------------
							If Skalierung > Feinjustierung Then
								skalieren(Skalierung - Feinjustierung)
								'________________________________________
								'Falls der Text doch einmal SEHR gross sein sollte,
								'darf Skalierung nicht sofort = 0 sein, sonst waere 
								'der Text ja "verschwunden", also muessen trotz vor-
								'definierter Feinjustierung noch kleinere Schritte erlaubt sein:
							ElseIf Skalierung > Feinjustierung/2.0 Then
								skalieren(Feinjustierung/2.0)
							ElseIf Skalierung > Feinjustierung/4.0 Then
								skalieren(Feinjustierung/4.0)
							Else
								skalieren(Feinjustierung/10.0)
							End If
							'-----------------------------------
						End If					
					ElseIf Ascii = 8 Then	'Zuruecknehmen-Taste
						'----------
						If LetzteZeile <> "" Then
							LetzteZeile = Left(LetzteZeile, Len(LetzteZeile) - 1)
							ListAddLast(Zeilenliste, LetzteZeile)
						ElseIf Skalierung < 1.0 Then
							Zeilenliste_komprimieren()
							skalieren(Min(1.0, Skalierung + 4*Feinjustierung)) 'wieder etwas groesser testen!
						ElseIf CountList(Zeilenliste) > 0 Then
							For LetzteZeile = EachIn Zeilenliste
							Next	'(nur damit wir wieder die richtige letzte Zeile erwischen!)
						Else
							LetzteZeile = "" 'mindestens eine (leere) Zeile sollte das Textfeld stets besitzen!
							ListAddLast(Zeilenliste, LetzteZeile)
						End If
						'----------
					Else  
						'----------
						If Ascii <> 9 Then	'normale Zeicheneingabe
							LetzteZeile = LetzteZeile + Chr(Ascii)
						Else 'If Ascii = 9 Then	''falscher'' Tabulator
							For Local t:Int = 1 To TabulatorLeerzeichenAnzahl
								LetzteZeile = LetzteZeile + " "
							Next
						End If
						'----------
						If Skalierung * TextWidth(LetzteZeile) <= Breite Then 'Rechts ist noch genug Platz
							ListAddLast(Zeilenliste, LetzteZeile)
						ElseIf (CountList(Zeilenliste)+2)*y_Schritt <= Tiefe Then 'Unterhalb ist auch fuer eine weitere Zeile noch genug Platz
							Local i:Int = Len(LetzteZeile) - 1
							Repeat
								If i = 0 Then 'gewaltsame Trennung, da in der gesamtem Zeile weder Leerzeichen noch Bindestrich gefunden wurde
									ListAddLast(Zeilenliste, Left(LetzteZeile, Len(LetzteZeile)-1))
									LetzteZeile = Chr(Ascii)
									ListAddLast(Zeilenliste, LetzteZeile)
									Exit
								ElseIf Mid(LetzteZeile, i, 1) = "-" Or Mid(LetzteZeile, i, 1) = " " Then
									ListAddLast(Zeilenliste, Left(LetzteZeile, i))
									LetzteZeile = Right(LetzteZeile, Len(LetzteZeile) - i)
									ListAddLast(Zeilenliste, LetzteZeile)
									Exit
								End If
								i = i - 1
							Forever
						Else 'der Text wird insgesamt zu gross => es bedarf einer kleineren Skalierung:
							ListAddLast(Zeilenliste, LetzteZeile)
							Zeilenliste_komprimieren()
							'------------------------------------
							If Skalierung > Feinjustierung Then
								skalieren(Skalierung - Feinjustierung)
								'________________________________________
								'Falls der Text doch einmal SEHR gross sein sollte,
								'darf Skalierung nicht sofort = 0 sein, sonst waere 
								'der Text ja "verschwunden", also muessen trotz vor-
								'definierter Feinjustierung noch kleinere Schritte erlaubt sein:
							ElseIf Skalierung > Feinjustierung/2.0 Then
								skalieren(Feinjustierung/2.0)
							ElseIf Skalierung > Feinjustierung/4.0 Then
								skalieren(Feinjustierung/4.0)
							Else
								skalieren(Feinjustierung/10.0)
							End If
							'-----------------------------------
						End If					
					End If
				End If
			End If
			'--------------------------------------------
			If Maus.Aktion = 1 Then
				If Maus.y < y Or Maus.y > y + Tiefe Or Maus.x < x Or Maus.y > x + Breite Then
					deaktivieren()
					FlushKeys()
				End If
			End If
			'--------------------------------------------
		Else   '(aktiv = False)
			'--------------------------------------------
			For Local Zeile:String = EachIn Zeilenliste
				DrawText Zeile, x, temp_y
				temp_y = temp_y + y_Schritt
			Next
			'--------------------------------------------
			If Maus.Aktion = 1 Then
				If Maus.y =< y + Tiefe Then
					If Maus.y >= y Then
						If Maus.x >= x Then
							If Maus.y =< x + Breite Then
								aktivieren()
							End If
						End If
					End If
				End If
			End If
		End If
		'--------------------------------------------
		SetScale 1.0, 1.0
		SetColor 255,255,255
		'--------------------------------------------
	End Method
	'---------------------------------------------------------------------------------------------------------
	Method nur_anzeigen()
		SetColor 0,0,0
		SetScale Skalierung, Skalierung
		Local temp_y:Float = y
		For Local Zeile:String = EachIn Zeilenliste
			DrawText Zeile, x, temp_y
			temp_y = temp_y + y_Schritt
		Next
		SetScale 1.0, 1.0
		SetColor 255,255,255
	End Method
	'===========================================================

End Type   '(TSkaliertesTextfeld)

